/*======================================智能人像分割（抠图）接口---人像抠图返回透明背景======================================*/
package main

import (
	"bytes"
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"log"
	"net/http"
)

func ImgtoBase64SegmentMatting(filePath string) string {
	//图片转Base64
	bytes, err := ioutil.ReadFile(filePath)
	if err != nil {
		log.Fatal(err)
	}
	var base64Encoding string
	base64Encoding += base64.StdEncoding.EncodeToString(bytes)
	return base64Encoding
}

func MD5SegmentMatting(v string) string {
	d := []byte(v)
	m := md5.New()
	m.Write(d)
	b := m.Sum(nil)
	return base64.StdEncoding.EncodeToString([]byte(b))
}

func main() {
	appCode := "你的appcode"
	SegmentMattingUrl := "https://matting.market.alicloudapi.com/segment/matting"

	client := &http.Client{}
	data := make(map[string]interface{})
	data["photo"] = ImgtoBase64SegmentMatting("1.jpg")
	data["type"] = "jpg"
	data["face_required"] = 0 // 可选，整形，检测是否必须带有人脸才进行抠图处理，0为检测，1为不检测，默认为0，设置这个参数后，可能导致人体背影无法抠图
	data["is_crop_content"] = 0 // 可选，整形，是否值返回人像区域，其余透明区域，都被裁剪掉，0为否，1为是，默认为0

	bytesData, _ := json.Marshal(data)
	req, _ := http.NewRequest("POST", SegmentMattingUrl, bytes.NewReader(bytesData))
	req.Header.Set("Content-Type", "application/json")
	req.Header.Set("Authorization", "APPCODE "+appCode)

	md5Str := MD5SegmentMatting(string(bytesData))
	req.Header.Set("Content-MD5", md5Str)

	resp, _ := client.Do(req)
	fmt.Println(resp.Header)
	fmt.Println(resp.Header["X-Ca-Error-Message"])
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))

}
